; BGFTDYPC.ASP: PCPLUS script for BGFT Ymodem Batch download.
; Copyright 1990-1991 Dirac Systems.
; Support Package for Registered users of BGFT (TM).
; PCPLUS is a trademark of Datastorm Technologies Inc.
;
; MANUAL INSTALLATION:
; The following outlines how to install the script for use as an
;      'external protocol' in PCPLUS. Actually, it shows how to
;       use an ASP script to do the file transfer in BGFT.
; Be sure that the resident part (BGFT360K.COM or BGFT720K.COM) of
;      BGFT is loaded before the communications program. Add /B if
;      you want Drive B:. The BGFT status window does not need to be
;      active; it need only be resident.
; The batch file BGFTINIT.BAT is used to initialize BGFT prior to
;      running PCPLUS. This file must be edited to contain information
;      about your modem's port number and baud rate prior to use
;      (default is 1200 baud, port 1). You must run the batch file
;      BGFTINIT.BAT to make sure that BGFT is set up properly. THIS
;      MUST BE DONE before using BGFT as an external protocol under
;      PCPLUS. This is true even though the baud and port are set here.
; BGFTOPT.EXE should be in the \PCPLUS directory or the PATH setup.
; BGFTDYPC.ASP should be in the \PCPLUS directory.
; Get the remote system ready to download the chosen files with Ymodem
;       batch.
; From terminal mode in PCPLUS hit 'Alt_F5' to begin to set up the ASP
;       file for running.
; Hit RETURN to get a list of ASP files.  Choose BGFTDYPC.ASP with the
;       up or down arrows to do a Ymodem Batch download.
; BGFTDYPC.ASP will initiate the download using the baud rate and comm
;       port defined below in the script file. The BYE command will exit
;       PCPLUS without hanging up; you will be at the DOS prompt. The
;       files(s) will be transferred in the background so you can use
;       your computer for other purposes while this takes place.
; DO NOT RUN PCPLUS FROM DOS OR YOU WILL GET THE TRANSMISSION ON THE
;       SCREEN INSTEAD OF THE FILE BUFFER.
; After the transfers are over you can use PCPLUS again in terminal
;       mode.
; Use BGFT.EXE to move your files to the desired DOS directory. Also,
;      the batch file, BGFTDUMP.BAT, may be used to dump downloaded
;      files from the file buffer to a specified directory (if none is
;      specified, then the current working directory is used).
;
MESSAGE" "
MESSAGE"    Copyright 1990-1991 Dirac Systems"
MESSAGE"                                       \ /"
MESSAGE"------------------------------------- - o -"
MESSAGE"                                       / \"
MESSAGE"BGFT Ymodem Batch Download External Protocol"
MESSAGE" "
ASSIGN S0 1                     ; USER DEFINED COMM PORT.
ASSIGN S1 1200                  ; USER DEFINED BAUD RATE.
ASSIGN S2 "BGFTOPT /Q"          ; Quiet mode (don't print out results).
STRCAT S2 " /A"                 ; Acknowledge error, if any.
STRCAT S2 " /R"                 ; Reconnect COMM port.
STRCAT S2 S0
STRCAT S2 " /B"                 ; Set baud rate.
STRCAT S2 S1
STRCAT S2 " /~"                 ; Set protocol.
STRCAT S2 "2"                   ; USER DEFINED PROTOCOL (Ymodem Batch Download).
STRCAT S2 " /S"                 ; Start file(s) transfer.
DOS S2                          ; Run BGFTOPT.EXE with appropriate command.
IF FAILURE
        MESSAGE "COMMAND.COM NOT FOUND"
        EXIT                    ; End script and go to terminal mode.
ENDIF
BYE                             ; Exit PCPLUS without hanging up.
